/*
  This program is free software published under the
  terms of the GNU Lesser General Public License.
  http://www.gnu.org/copyleft/lesser.html    
  This program is distributed in the hope that it will
  be useful - WITHOUT ANY WARRANTY; without even the
  implied warranty of MERCHANTABILITY or FITNESS FOR A
  PARTICULAR PURPOSE.
*/ 

// let and const are not used because of backward compatibility

var clock = 100;  // basic timer resolution in ms
var timer_id = null;   // timer_id is the identifier of the repeated action you want to cancel. This ID is returned from setInterval().
var step = -1;   // global timer counter 
var item = 0;   // current item      
var cor = [];   // correct answer (dot/circle with offset) within each item
var ans = [];  //  user answers for each item (dependent var) 
var xy = [];    //  jagged array [item][] Within each [item] is separate array with grid coordinates [0.index= x; 1.index =y]
var p_cur = 0;   // current point see: drawPoint()
var r = 10;        // dot/circle radius (px) 
var edge = r;     // canvas border 
var hor= [];      // direction => horizontal line (true) or vertical line (false)
var flp = [];     // demo mode => xy-coordinates of first and last point for each item   => 1dim = item; 2dim= first or last point;  3dim= x or y coord (0 = x, 1=y) 
var idle = 0;     // global timer counter (escape drawing point)
var dirty = false;  // if  (dirty==true) => user changed any options in form
var cc= 10;         //  number of imaginary circles

// var parameters are bellow (11)  - Synchronize this section with wm5.html form parameter values 
var parad = "1";      // if (parad === "1") => line task; if (parad==="2") => divide task; if (parad==="3") => imaginary circle task  
var rnd = false;  //  random (true) or pseudorandom (false) generator
var jumping = false;   // if  jumping = true => the points will not appear on the imaginary line from one to the other (from left to right or vice versa), but the points will be shown by a random event
var item_cnt = 6;   // total item count
var p_cnt = 5;   // total point (circle) count
var offset = 3;   // point offset (task difficulty)
var before = 6;      // number of basic time cycles BEFORE first circles exposition (x clock).   Better to choose EVEN number (2,4,6,..)
var time = 5;      // (stimulus exposition time) in ms (x clock)   
var after = 5;       // delay between stimulus and response (number of basic time cycles) =>  (x clock)  
var monochrome= true;   // if true monochrome (black) color circle.  false = circles  will be in random Colors
var demo = true;   // demo mode = true => show correct solution


// create/start Timer, [center panels], and show start panel.. 
function init() {    
  if (timer_id)  {   
    window.clearInterval(timer_id);  
  }  
  timer_id= setInterval(function () {my_timer()},clock); // Returns an intervalID. intervalID is a unique interval ID you can pass to clearInterval()  
  if (!supportedTransform())  {
    doCenter(document.getElementById("start"));
    doCenter(document.getElementById("response"));
  }  
  showStart();
}


function supportedTransform() {
  var prefixes = "transform WebkitTransform MozTransform OTransform msTransform".split(" ");
  var div = document.getElementById("wrapper");
  for(var i = 0; i < prefixes.length; i++) {
    if(div && div.style[prefixes[i]] !== undefined) {
      return prefixes[i];
    }
  }
  return false;
}


function doCenter(e)  {
  if (e.id === "start")  {        
    e.style= (window.innerWidth > 600 && window.innerHeight > 600 ) 
    ? "position:absolute;min-width:50%;min-height:50%;margin:auto;overflow:auto;"  
    : "position:absolute;min-width:75%;min-height:75%;margin:auto;overflow:auto;";  
  }
  else if (e.id === "response")  {
    e.style="position:absolute;min-width:50%;min-height:50%;margin:auto;overflow:auto;";    
  } 
}


// show main start panel 
function showStart()  {      
  document.getElementById("end").style.display= "none";
  document.getElementById("google-wrapper").style.display="none";  
  document.getElementById("start").style.display= "block";
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
function showOption()   {
  document.getElementById("hide_option").style.display ="block";
  document.getElementById("options").style.display= "block";
  document.getElementById("start").classList.remove("child");  // don't work in <= IE 9    
  document.getElementById("start_div").style.display="none";  // .disabled = true;   
  document.getElementById("show_option").style.display ="none";  
  document.getElementById("hide_option").style="text-align:center";  // bug? auto-remove style when element.style.display="none"
  document.getElementById("ins_parad1").style.display ="none"; 
  document.getElementById("ins_parad2").style.display ="none"; 
  document.getElementById("ins_parad3").style.display ="none";
  dirty= false;
}


// <!-- IMPORTANT: showOption() and hideOption() buttons must be outside form element -->
// save to window global vars all user defined research Options
function hideOption()  {
  setVarPar();   
  document.getElementById("options").style.display="none"; 
  document.getElementById("start").classList.add("child");   
  document.getElementById("show_option").style.display ="block";   
  document.getElementById("start_div").style.display="block";        //.removeAttribute("disabled");  
  document.getElementById("hide_option").style.display ="none";   
  document.getElementById("start_div").style="text-align:center";  // bug?  (firefox auto remove class "center" when set style.display.none;)
  document.getElementById("show_option").style="text-align:center";   // bug?
  changeIns(); 
  refMsg() ;  
}


function refMsg()   {
 if ( optionsValid() )   {
    document.getElementById("is_valid").textContent=  (dirty===true) ? "All your settings have been successfully updated" : "";  
    document.getElementById("is_valid").style="text-align:center;color:#000000"; 
  }
  else  {
    document.getElementById("is_valid").textContent="Some of your options are incorrectly set. They were not updated. These settings are marked in red."; 
    document.getElementById("is_valid").style= "text-align:center;color:#ff0000;font-weight:bold"; // safari 5.1.7 bug? => this don't work
  } 
}


function optionsValid()  {
  return ( 
    document.getElementById("paradigm").validity.valid  &&  
    document.getElementById("random").validity.valid  &&  
    document.getElementById("jumping").validity.valid && 
    document.getElementById("item_cnt").validity.valid   &&  
    document.getElementById("p_cnt").validity.valid && 
    document.getElementById("offset").validity.valid &&       
    document.getElementById("before").validity.valid && 
    document.getElementById("time").validity.valid && 
    document.getElementById("after").validity.valid );  
}

         
/* refresh paradigm Option (update *_msg label) => give user short option HELP
   count variable properties count: 11  */
function refOption(e)  {
  dirty=true;      
  var my_id = e.id, msg = document.getElementById(my_id + "_msg"), s = "Values within this range are allowed: ", s2= " with step= ";
  if ( my_id === "paradigm" )  { 
    if (e.value === "1")  {
      msg.textContent= "User must specify one point that is NOT within the same imagined line (0 = for none)";          
      document.getElementById("jumping_msg").textContent= (document.getElementById("jumping").value === "0") ? "The dots will appear to each other (one to the other)" : "The dots will appear in an random sequence";
      document.getElementById("jumping").disabled= false; // document.getElementById("jumping").removeAttribute("disabled");
    }
    else if (e.value === "2")   {
      msg.textContent= "User must specify one of the points NOT in the same distance from the others (0 = for none)";
      document.getElementById("jumping_msg").textContent= "Not available for the selected paradigm"; 
      document.getElementById("jumping").disabled= true; //   document.getElementById("jumping").setAttribute("disabled", "true");      
    }    
    else   {
      msg.textContent= "The user must find a point that is not in the same imagined circle (0 = for none)";
      document.getElementById("jumping_msg").textContent= (document.getElementById("jumping").value === "0") ? "The dots will appear to each other (one to the other)" : "The dots will appear in an random sequence";
      document.getElementById("jumping").disabled= false;  //   document.getElementById("jumping").setAttribute("disabled", "true");      
    }      
  }
  else if ( my_id === "random")  {
    msg.textContent= (e.value === "0") ? "The solutions of all tasks will be selected randomly" : "Solutions will be selected so that their number is balanced (approximately equal)";
  }
  else if ( my_id === "jumping")  {  
    msg.textContent= (e.value === "0") ? "The dots will appear to each other (one to the other)" : "The dots will appear in an random sequence";
  }      
  else if ( my_id === "item_cnt")  {        
    if (e.validity.valid)  {
      msg.textContent= "Total number of tasks: " + e.value;
      msg.removeAttribute("class");  
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");    // msg.className = 'error';
    }
  }   
  else if ( my_id === "p_cnt")  {
    if (e.validity.valid)  {
       msg.textContent= "Number of dots in each task: " + e.value; 
       msg.removeAttribute("class"); 
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");    // msg.className = 'error';
    }
  }
  else if ( my_id === "offset")  {
    if (e.validity.valid)  {
      msg.textContent= "A larger number means a more complicated task (1..5). Offset: " + e.value;
      msg.removeAttribute("class");
     }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step; 
      msg.setAttribute("class", "error");
    }
  }     
  else if ( my_id === "before")  {
    if (e.validity.valid)  {
      msg.textContent=  e.value + " ms"; 
      msg.removeAttribute("class");
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step; 
      msg.setAttribute("class", "error");
    }          
  }  
  else if ( my_id === "time")  {
    if (e.validity.valid) {
      msg.textContent= e.value + " ms"; 
      msg.removeAttribute("class");
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");
    } 
  }  
  else if ( my_id === "after")  {
    if ( e.validity.valid ) {
      msg.textContent= e.value + " ms (also Time delay = Time of displaying the correct answer)";
      msg.removeAttribute("class");
    }
    else  {
      msg.textContent= s + e.min + ".." + e.max + s2 + e.step;
      msg.setAttribute("class", "error");
    }
  }              
  else if (my_id === "monochrome")  {
    msg.textContent= (e.checked) ? " (Dots will only appear in black - monochrome)" : " (Dots will be displayed in full color or only black-red in demo mode)";
  }
  else if ( my_id === "demo")  {
    msg.textContent= (e.checked) ? " (Yes - demo mode)" : " (No)";    
  }
  refMsg();   
}


// update paradigm instruction
function changeIns()  { 
 var e= document.getElementById("paradigm").value;
 if (e === "1") {       
   document.getElementById("ins_parad1").style.display= "block"; 
   document.getElementById("ins_parad2").style.display= "none";
   document.getElementById("ins_parad3").style.display= "none";
   
   document.getElementById("ans_parad1").style.display= "block";
   document.getElementById("ans_parad2").style.display= "none";   
   document.getElementById("ans_parad3").style.display= "none";           
 }
 else if (e === "2")  {      
   document.getElementById("ins_parad2").style.display= "block";
   document.getElementById("ins_parad1").style.display= "none";
   document.getElementById("ins_parad3").style.display= "none"; 
   
   document.getElementById("ans_parad2").style.display= "block"; 
   document.getElementById("ans_parad1").style.display= "none";   
   document.getElementById("ans_parad3").style.display= "none";   
 } 
 else   {
   document.getElementById("ins_parad3").style.display= "block"; 
   document.getElementById("ins_parad1").style.display= "none";
   document.getElementById("ins_parad2").style.display= "none";   
   
   document.getElementById("ans_parad3").style.display= "block";
   document.getElementById("ans_parad1").style.display= "none";   
   document.getElementById("ans_parad2").style.display= "none";   
 }
}


// start Test (Research)
function startTest()   {    
  setPar();  
  if (r < 1)  {
    document.getElementById("is_valid").textContent="Too small screen resolution. In Options, you need to reduce the number of dots or change the paradigm";  
    document.getElementById("is_valid").style= "color:red;font-weight:bold;text-align:center";
    return;
  }   
  rndSol();  // must be before setCoord()  
  document.getElementById("canvas").width= window.innerWidth;       // stretch canvas width to doc window        
  document.getElementById("canvas").height= window.innerHeight;    // stretch canvas height to doc window        
  (parad ==="3") ? setCoord3(): setCoord12();        
  document.getElementById("google-wrapper").style.display="none";
  document.getElementById("end").style.display= "none"; 
  document.getElementById("start").style.display= "none"; 
  document.getElementById("canvas").style.display="block";         //document.getElementById("answer_val").textContent= "";
  idle= 0;        // reset global timer counter (escape drawing point)
  item=0;
  step=0;   // "activate" Timer   
}


// set user variable parameters (count=11); not use this code in setPar() => eq: document.getElementById("time").value are not updated to real value!!  
function setVarPar()  {   
  parad= document.getElementById("paradigm").value;    // if (parad === "1") => line task; if (parad==="2") => divide task; if (parad==="3") => imaginary circle task  
  rnd =  (document.getElementById("random").value === "0") ? true : false; //  random (true) or pseudorandom (false) generator
  jumping = (document.getElementById("jumping").value === "1") ? true : false;   // jumping or not jump  
  if (document.getElementById("item_cnt").validity.valid) item_cnt= parseInt(document.getElementById("item_cnt").value); 
  if (document.getElementById("p_cnt").validity.valid) p_cnt= parseInt(document.getElementById("p_cnt").value);
  if (document.getElementById("offset").validity.valid) offset= parseInt(document.getElementById("offset").value);   
  if (document.getElementById("before").validity.valid) before= Math.round(parseInt(document.getElementById("before").value, 10)/clock);
  if (document.getElementById("time").validity.valid) time= Math.round(parseInt(document.getElementById("time").value, 10)/clock);  
  if (document.getElementById("after").validity.valid)  after= Math.round(parseInt(document.getElementById("after").value, 10)/clock); 
  monochrome= (document.getElementById("monochrome").checked) ? true: false;  // if true monochrome (only black) color circle.  false = circles  will be in random Colors
  demo= (document.getElementById("demo").checked) ? true: false; // demo mode = true => show correct solution
  if (parad === "2") jumping= false;      
}


// application set research (paradigm) parameters => this is not available to user
function setPar()  { 
  //edge= Math.round(0.05 * Math.min(window.innerWidth,window.innerHeight));    //  5% min (width, height)   
  r = Math.floor(Math.min(window.innerWidth,window.innerHeight))/(p_cnt+3);  // divide screen into equal parts:  p_cnt + 1*up/left edge + 1*down/right edge     
  if (parad === "1")  {
    r= r/2;        // circle d= 2*r
  }
  else if (parad ==="2")  {
    r= r/(10);       // circle d= 2*r   => must have space when divide line into 5 equal parts (5*2=10)
  }
  else  {
    r = Math.floor(Math.floor(Math.min(window.innerWidth/2,window.innerHeight/2)-Math.min(window.innerWidth/8,window.innerHeight/8))/(cc+1));   // inner edge = r; outer edge = r    
  }
  edge= r;          
  cor = [];   // correct number of visible shapes within each item
  ans = [];   //  user answers for each item (dependent var)
  xy = [];    //  jagged array [item][] Within each [item] is separate array with grid coordinates [0.index= x; 1.index =y]  
  hor= [];    // direction => horizontal line (true) or vertical line (false)  
}

 
// stimulus generator for (parad === "1") => line task; if (parad==="2") => divide task
// generate window.p_cnt circles for each window.item_cnt => xy[item_cnt][0..p_cnt-1] with or without window.offset
function setCoord12()  
{   
  var x1, x2, y1, y2;  // first point (x1,y1) => with index: 0; last point (x2,y2) with index: p_cnt-1       
  var dx, dy, lrt, tmp; // x, y coord for all other point (1..p_cnt-2), left-to-right or right-to-left line direction, tmp 
  var canvas = document.getElementById("canvas");                     
  for (var i=0; i<item_cnt; i++)  
  {    // i= item
    xy[i]= [];          
    if (Math.random() < 0.5)      
    { // horizontal line  
      hor[i]= true;
      y1= getRndInt(edge, canvas.height-edge);   // first point (x1,y1) => random y-coord (index: 0)    
      x1= edge;  /*(parad==="1") ? edge : getRndInt(edge, off * edge);*/    // first point (x1,y1) => x-coord (index: 0)                                       
      x2= canvas.width-edge; /*(parad ==="1") ? canvas.width-edge : getRndInt(canvas.width-edge-off*edge, canvas.width-edge);*/    // last point (x2,y2) => x-coord  (index: p_cnt-1)  
      do {
        y2= getRndInt(edge, canvas.height-edge);     // last point (x2,y2) => y-coord  (index: p_cnt-1)   
      }
      while (Math.abs(y1 - y2) < canvas.height/5); // must have minimum angle      
    }
    else  
    { // vertical line
      hor[i]= false;       
      x1= getRndInt(edge, canvas.width-edge);   // first point (x1,y1) => random x-coord (index: 0)             
      y1= edge; /*(parad === "1") ? edge: getRndInt(edge, off * edge) ;*/   // first point (x1,y1) => y-coord (index: 0)
      y2= canvas.height-edge;  /*(parad === "1") ? canvas.height-edge: getRndInt(canvas.height-edge-off*edge, canvas.height-edge);*/   // last point (x2,y2) => y-coord  (index: p_cnt-1)        
      do {
        x2= getRndInt(edge, canvas.width-edge);   // last point (x2,y2) => x-coord  (index: p_cnt-1)   
      }
      while (Math.abs(x1 - x2) < canvas.width/5); // must have minimum angle               
    }     
    xy[i].push([x1, y1]);    // first one (index: 0)
    var tmp= p_cnt-2;    // divide line into p_cnt-2 equal segments
    for (var j=1; j<=tmp; j++)  {
      dx= div_x(x1, x2, -j/(tmp-j+1));    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1 
      dy= div_y(y1, y2, -j/(tmp-j+1));    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1               
      xy[i].push([dx, dy]);        
    } 
    xy[i].push([x2, y2]);  // last point with index: (p_cnt-1)  
  }   // i = for item_cnt 
  
  for (var i=0; i<item_cnt; i++)  
  {      
    lrt =  (Math.random() < 0.5 ) ? true : false;   // left-to-right or right-to-left line direction
    if (lrt)  xy[i].reverse();        // reverse random 50%
  }  
  memo_flp();   
  if (jumping)   {
    for (var i=0; i<item_cnt; i++)  { 
      xy[i]= shuffle(xy[i]);   
    }                     
  }
  // add random offset for each target (correct solution) point based on window.offset 
  if (parad === "1")  {
    var my_off= (3 + 3 - window.offset);  // local offset => don't change window.offset
  }
  else  {
    var my_off= -(6-offset)/offset;       // my_off= -(6-j)/j;
  }   
  for (var i=0; i<item_cnt; i++)  
  {    // i= item     
    for (var j=0; j<=p_cnt-1; j++)  
    {             // for each point in each item (task)        
      if  (j === cor[i]-1)     
      {  // change coord - add random offset for correct answer =>  if this point is correct  answer                  
        if (parad === "1")  
        {           
          if (hor [i] == true) {
           xy[i][j][1]+=  y_offset(xy[i][j][1], my_off);    // add random y-offset => [1]= y         
          }
          else  {
            xy[i][j][0]+= x_offset(xy[i][j][0],  my_off);   // add random x-offset =>  [0]= x                   
          }
        }
        else  
        {           
          var x1=xy[i][j][0];   // this point x-coord
          var y1=xy[i][j][1];   // this point y-coord
          if ( j < p_cnt-1 )  {   // every point except last
            var x2=xy[i][j+1][0];  // next point x-coord
            var y2=xy[i][j+1][1];    // next point y-coord
            //my_off= -(6-offset)/offset;       // my_off= -(6-j)/j;
          }
          else  {           // only each last point
            var x2=xy[i][j-1][0];  // prior point x-coord
            var y2=xy[i][j-1][1];    // prior point y-coord 
            //my_off= -offset/(6-offset);     //my_off= -j/(6-j);
          }                    
          xy[i][j][0]= div_x(x1, x2, my_off);    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1 
          xy[i][j][1]= div_y(y1, y2, my_off);    // last arg = lambda = -m/n. ex za step= 3: -1/3, -2/2, -3/1               
        }   
      }    //  if  ( j == cor[i]-1)  => if this point is correct              
    }    // for (var j=0; j<=p_cnt-1; j++)     => each point    
  }    //   for (var i=0; i<item_cnt; i++)  => each item
  
}


// stimulus generator for (parad === "3") => imaginated  circle
// generate window.p_cnt circles for each window.item_cnt => xy[item_cnt][0..p_cnt-1] with or without window.offset
function setCoord3()   {
    
  for (var i=0; i<item_cnt; i++)  
  {    // i= item
    xy[i]= [];          
    hor[i]= (Math.random() < 0.5) ? true: false;   // horizontal line    
    var rnd= getRndInt(1,cc);   // random circle count 1..10  => (1..number of imaginary circles)      
    var angle= getRndInt(0,2*Math.PI);  
    for (var ind=0; ind < p_cnt; ind++)  {
      var x = canvas.width/2  + (Math.min(window.innerWidth/8,window.innerHeight/8)+rnd*r) * Math.cos(angle);    // polar radius = (Math.min(window.innerWidth/8,window.innerHeight/8)+rnd*r) 
      var y = canvas.height/2 + (Math.min(window.innerWidth/8,window.innerHeight/8)+rnd*r) * Math.sin(angle);     // polar coordinate y
      xy[i].push([x, y]);    // save polar coordinates (x,y)     
      angle+= 2*Math.PI/p_cnt;          
    }  
  }   
  for (var i=0; i<item_cnt; i++)  {      
    if  (Math.random() < 0.5 ) xy[i].reverse();   // counterclockwise or clockwise  => reverse random 50%
  }       
  if (jumping)   {
    for (var i=0; i<item_cnt; i++)  { 
      xy[i]= shuffle(xy[i]);   
    }                     
  } 
  
  // this must be after shuffle() [reverse()] function calls => add random offset for each target (correct solution) point based on window.offset   
  var my_off= (3 + 3 - window.offset);  // point offset
  for (var i=0; i<item_cnt; i++)  
  {    // i= item
    for (var j=0; j<=p_cnt-1; j++)  
    {             // for each point in each item (task)        
      if  ( j === cor[i]-1)    
      {         // correct answer (target dot) => add random offset for each target (correct solution) point based on window.offset       
        if (Math.random() < 0.5) {     
          xy[i][j][1]+=  y_offset(xy[i][j][1], my_off);    // 50% add random y-offset => [1]= y            
        }
        else  {      
          xy[i][j][0]+= x_offset(xy[i][j][0],  my_off);   // 50% add random x-offset =>  [0]= x                      
        }    
      }       
    } 
  } 
    
}


// x1 => first point P1 x-coord
// x2 => second point P2 y-coord
// n => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: x-coord of Q point
function div_x(x1,x2,n)  {   
  return (x1-n*x2)/(1-n);
}


// y1 => first point P1 y-coord
// y2 => second point P2 y-coord
// n  => (distance(P1-Q)/ distance(Q-P2)) = lambda = -m/n = negative ratio length: P1-Q/Q-P2
// returns: y-coord of Q point
function div_y(y1,y2,n)  {   
  return (y1-n*y2)/(1-n);
}


// unbiased shuffle algorithm: Fisher-Yates (aka Knuth) Shuffle.
function shuffle(arr) {
  var cur_index = arr.length, tmp, rnd_index;
  // While there remain elements to shuffle...
  while (0 !== cur_index) {    
    rnd_index = Math.floor(Math.random() * cur_index);     // Pick a remaining element...
    cur_index = cur_index - 1;   
    tmp = arr[cur_index];          // And swap it with the current element.
    arr[cur_index] = arr[rnd_index];
    arr[rnd_index] = tmp;
  }
  return arr;
}


// memorize each start point and end point  (remember they can be shuffled  if (window.jumping==true) ). see drawPoint()
function memo_flp()  {
  for (var i=0; i<item_cnt; i++)  {            
    flp[i]= [];          
    flp[i].push( [ xy[i][0][0], xy[i][0][1] ] );    // first point: x-coord for i-item, first point y-coord for i-item    
    flp[i].push( [ xy[i][p_cnt-1][0], xy[i][p_cnt-1][1] ] );    // last point: x-coord for i-item, last point y-coord for i-item
  } 
}

// set random or pseudorandom (equal frequencies for each categories) solutions
function rndSol()  { 
  if  (rnd)    {
  for (var i=0; i<item_cnt; i++)  {  
      cor[i]= Math.floor(Math.random()*(p_cnt+1));      // returns a random integer from 0 to p_cnt
  } 
  }
  else   
  {  
    var cat= p_cnt+1;      // number of categories
    var m= Math.floor(item_cnt/(cat));   // maximum permitted number (frequency)    
    if (m<1) m= 1;        
    var freq= [];   //  frequency array => previously selected frequencies. each must be < m
    for (var i=0; i<=p_cnt; i++)  {
      freq[i]= 0; 
    }          
    // pseudorandom generator = each category must have equal frequency 
    for (var i=0; i<cat*m && i<item_cnt; i++)  {    
      do
        var tmp= Math.floor(Math.random()*cat);      // returns a random integer from 0 to p_cnt  
      while  (freq[tmp]+1 > m);
      cor[i]= tmp;
      freq[tmp]++;
    }
    // for remainder items => each category only once <= (m+1)     
    for (var j=i; j<item_cnt; j++)  {    
      do
        var tmp= Math.floor(Math.random()*cat);      // returns a random integer from 0 to p_cnt  
      while (freq[tmp]+1 > m+1);
      cor[j]= tmp;
      freq[tmp]++;           
    }     
  }                             
}


function getRndInt(min, max) {
    return Math.floor(Math.random() * (max - min + 1)) + min;
}


function drawCross()  {
  var canvas= document.getElementById("canvas");   
  var x= Math.round(canvas.width/2);
  var y= Math.round(canvas.height/2);
  var d = Math.floor(Math.min(x,y)/4);  // 1/8 min(width, height)  
  drawLine(x-d,y,x+d,y); // horizontal
  drawLine(x,y-d,x,y+d); // vertical 
}


function drawLine(x1,y1,x2,y2)  {
  var ctx= document.getElementById("canvas").getContext('2d'); 
  ctx.beginPath();
  ctx.moveTo(x1,y1);
  ctx.lineTo(x2,y2);
  ctx.lineWidth= 1;
  ctx.strokeStyle="#000000";  // always black
  ctx.stroke();     
}


// p_cur => ordinal number of visible point (circle)
function drawPoint(p_cur)  {    
  //if (p_cur < 0 || p_cur > p_cnt-1) return;  
  var ctx = document.getElementById("canvas").getContext('2d'); 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas        
  var flag = ( p_cur == cor[item]-1 && demo) ? true : false;   // draw target point in red color (only in demo mode)                                   
  drawCircle(xy[item][p_cur][0], xy[item][p_cur][1], flag);
  //drawBorder();                 
}


// show correct solution in Demo mode
function drawDemo()  {
  //if (p_cur < 0 || p_cur > p_cnt-1) return;  
  var canvas= document.getElementById("canvas");
  var ctx = document.getElementById("canvas").getContext("2d"), flag, x, y, d=0; 
  ctx.clearRect(0, 0, canvas.width, canvas.height);      // clear canvas        
  for (var j=0; j<=p_cnt-1; j++)  
  {   
    flag = (j === cor[item]-1) ? true : false;       // draw target point in red color  (always for this procedure)                            
    drawCircle(xy[item][j][0], xy[item][j][1], flag);    // don't change offset coord (they are already changed in drawPoint - must be changed only once)         
    ctx.font = r + "px Arial";         // begin of draw point number within each Circle
    ctx.textAlign = "center";
    ctx.fillStyle = ( flag ) ? "#000000" : "#ff0000";  // fill in black or red color
    ctx.fillText((j+1), xy[item][j][0], xy[item][j][1]);     // end of draw point number within each Circle
    if (!flag && parad === "3" && d ===0) {      // non-target stimulus for imagined circle paradigm
       d  = Math.sqrt( (xy[item][j][0] - canvas.width/2) * (xy[item][j][0] - canvas.width/2)  + (xy[item][j][1] - canvas.height/2)*  (xy[item][j][1] - canvas.height/2) );
    }                    
  }       
  if (parad === "3")  {
    ctx.beginPath();
    ctx.arc(canvas.width/2, canvas.height/2, d, 0, 2*Math.PI);     //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);                         
    ctx.lineWidth = 1;
    ctx.strokeStyle= "#000000";      
    ctx.stroke(); 
    //ctx.font= 0.1*document.getElementById("canvas").height + "px Calibri";   // the height of the text in pixels is equal to the font size in pts when the font is defined with the font property of the canvas context
    ctx.fillStyle = "lime"; // fuchsia     
    ctx.fillText("Correct: " + cor[item], canvas.width/2, canvas.height/2);            
  }
  else  
  {
    drawLine(flp[item][0][0], flp[item][0][1], flp[item][1][0], flp[item][1][1]);
    if (hor[item])  {
      x= ( flp[item][0][0] <= canvas.width/2) ? 0.25*canvas.width : 0.75*canvas.width; // ltr = true/false
      y= ( flp[item][0][1] <= canvas.height/2) ? 0.75*canvas.height : 0.25*canvas.height;   
    }
    else  {
      x= ( flp[item][0][0] <= canvas.width/2) ? 0.75*canvas.width: 0.25*canvas.width; // ltr = true/false
      y= ( flp[item][0][1] <= canvas.height/2) ? 0.25*canvas.height : 0.75*canvas.height;   
    }        
    //ctx.font= 0.1*document.getElementById("canvas").height + "px Calibri";   // the height of the text in pixels is equal to the font size in pts when the font is defined with the font property of the canvas context
    ctx.fillStyle = "lime"; // fuchsia     
    ctx.fillText("Correct: " + cor[item], x, y); 
  }
  //drawBorder();     
}


function drawCircle(x,y,is_red)  {
  var ctx = document.getElementById("canvas").getContext('2d');
  ctx.beginPath();
  ctx.arc(x,y,window.r,0,2*Math.PI);     //ctx.arc(x,y,r,sAngle,eAngle,counterclockwise);       
  if (!demo) { 
    (monochrome==true) ? ctx.fillStyle = "black" : ctx.fillStyle= getRandomColor();       //ctx.fillStyle =  (xy[item][i][2] == 0) ?  "black" : "red";    //  getRandomColor();          
  }
  else  {
    (is_red==true)  ? ctx.fillStyle = "red" :  ctx.fillStyle = "black";   
  }
 ctx.fill();
}


// par: x = dot x-coord;   dif = real number = dot offset => difficulty
// return x offset in range +/-[ dif * 0.05*window.innerWidth] 
function x_offset(x,dif)  {
  var off = (Math.random() < 0.5) ? 0.05*window.innerWidth*dif  : -0.05*window.innerWidth*dif;    // 50% chance => sign +/-           
  if (x + off < edge || x + off > window.innerWidth - edge) off=-1*off;  
  return off;
}


// par: y = dot y-coord;   dif = real number = dot offset => difficulty  
// return y offset in range +/-[ dif * 0.05*window.innerHeight] 
function y_offset(y,dif)  {
  var off = (Math.random() < 0.5) ? 0.05*window.innerHeight*dif  : -0.05*window.innerHeight*dif;    // 50% chance => sign +/-           
  if (y + off < edge || y + off > window.innerHeight - edge) off=-1*off;  
  return off; 
}


function getRandomColor() {
  var letters = '0123456789ABCDEF';
  var color = '#';
  for (var i = 0; i < 6; i++) {
    color += letters[Math.floor(Math.random() * 16)];     // returns a random integer from 0 to 15 
  }
  return color;
}  


// main application Timer handler
function my_timer()  
{        
  if (step<0) return;  // nop, idle
  step++;  
  var canvas= document.getElementById("canvas");  
  if (step < before-1)  
  {  // time before main stimulus (points) period
    p_cur = 0;             
    if (step % 2 !== 0)  {     // always trigger this in first timer call
     drawCross();     // Draw Cross only if it is odd number  (1,3,5,..)  example if (before==6) = 3xflick     
    }
    else   {       // for even numbers  (2,4,6,..) => clear previous cross
     canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);     // clear canvas => clear Cross in 2,4,6 step 
    }        
  }      
  else if (step === before-1)   
  {   // clear last cross if exists     
    canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);     // ALWAYS clear canvas before main stimulus display
    idle= time-1;   // draw 1. point in next timer call (after 100ms clock)  => because step =1 (escape first 100ms clock time)  
  }    
  else if (p_cur < p_cnt)  
  {   // start with main stimulus (points/circles) drawing   
    idle++;
    if (idle == time )   
    {        // escape until time period (time=each point presentation time) is trigger
      canvas.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);     // clear previous point
      drawPoint(p_cur);         // draw crrent point
      p_cur++;   // this don't work in drawPoint() 
      idle=0;     // reset escape (idle) counter       
    }            
  }        
  else if (p_cur >= p_cnt)  
  {   // delay period   
     idle++;
     if (idle < after) return;    // escape until delay period is trigger
     if (demo && p_cur == p_cnt ) {       
       drawDemo();    
       p_cur++;     
       idle=0;               
     }
     else  {              // nop (only erase stimulus) in delay period       
       step = -1;         // Timer is Finally "stop", nop, idle, do none, Timer no operation
       p_cur = 0;       
       showResponse();  
     }  
   }   
     
} 


function keyUp(event)  {          
  var e = event ||  window.event;    // event = use the value of event if available or   window.event = if not assume it's IE and use window.event   
  e.preventDefault();            
  if (e.keyCode === 13) {   
    nextItem();         
  }
}


function nextItem()  {
  var node= document.getElementById("answer");
  var tmp =  node.value;  
  if (!node.validity.valid) {    // (!node.validity.valid || !isInt(tmp) || tmp < 0 || tmp > 99)      
    document.getElementById("answer_val").textContent= "Enter an integer from 0 to 99"; 
    document.getElementById("answer").focus(); 
    return;
  } 
  document.getElementById("answer_val").textContent=""; 
  tmp = Math.round(parseInt(tmp, 10));       
  ans[item]= tmp;     // store validated user answer 
  node.value= "";          // reset user answer (default answer for next item)
  node= document.getElementById("response");
  node.style.display="none";            
  if (item < xy.length - 1) {    // show next task       
    idle= 0;
    item++;
    document.getElementById("canvas").style.display="block";
    step=0;     // "activate" Timer again 
  }
  else  {               
    document.getElementById("response").style.display="none";
    document.getElementById("end").style.display="block";  
    theEnd();    
  }
}


function trim(str) {
   return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
}


// show response div (panel with user answer)
function showResponse()  {
  var node= document.getElementById("canvas");
  node.getContext("2d").clearRect(0, 0, canvas.width, canvas.height);     // clear canvas 
  node.style.display="none"; 
  var node= document.getElementById("response");
  node.style.display="block"; 
  document.getElementById("answer").focus(); 
}


function theEnd()  {
  var res=0;  
  for (var j=0; j!=cor.length; j++)   {
    if (cor[j] == ans[j]) res++;
  }
  var elem= document.getElementById("score");
  elem.textContent="Your score is: " + res + "   from possible: " + cor.length + "   Percentage: " + Math.round(100*res/cor.length) + "%";
  document.getElementById("google-wrapper").style.display="block";
  document.getElementById("no_google").textContent="";
  try  {
    drawClientData(res);
  }
  catch (e)  {
    document.getElementById("no_google").textContent= "You must have an available internet connection to display graphs and tables. Make sure you are online."; 
  }          
}


function drawClientData(res) {    
  //    xxxxxxxxxxx     chart2 => BarChart   xxxxxxxxxxxxxxxxx  
  var data = new google.visualization.DataTable();    // Create and populate the data table. 
  data.addColumn('string', 'Item number');     // 1. col = ans array = must be string  
  data.addColumn('number', 'Answer');      
  data.addColumn('number', 'Correct'); 
  data.addColumn('number', 'Item score');    
  for(var i = 0; i < ans.length; i++)  {  
    var tmp= (ans[i] === cor[i]) ? 1: 0;
    data.addRow( [  (i+1).toString() + ". item",  ans[i],  cor[i], tmp ] );        
  }                    
  options= {
   title: 'Total score = ' + res,
   width: '100%'   
  };    
  document.getElementById("chart2").style.display = "block";   
  new google.visualization.ColumnChart(document.getElementById('chart2')).draw(data, options);     // Create and draw the visualization.    
  //    xxxxxxxxxxxxxx          Frequencies table        xxxxxxxxxxxxxxxxx                             
  options= {      
    'width': '50%',    
    'allowHtml': true, 
    'sort': 'enable',  
    'alternatingRowStyle': true              
  };    // data are same         
  var elem= document.getElementById("table");
  elem.title="Total score=" + res;
  elem.style.display = "block"; 
  new google.visualization.Table(elem).draw(data, options);     
}

// debug method are bellow

/*
function drawBorder()   {
  var ctx = document.getElementById("canvas").getContext('2d'); 
  drawLine(edge, edge, canvas.width-edge, edge);
  drawLine(canvas.width-edge, edge, canvas.width-edge, canvas.height-edge); 
  drawLine(canvas.width-edge, canvas.height-edge, edge, canvas.height-edge);
  drawLine(edge, canvas.height-edge, edge, edge);
}

function isInt(n) {       
   return (!isNaN(n)) && (parseFloat(n) === parseInt(n, 10)) &&  (n % 1 === 0); 
} 
*/